<template>
  <div
    ref="element"
    :class="{ 'BacklogOrder--moving': moving }"
    :draggable="true"
    :style="scheduleToStyle"
    class="BacklogOrder"
    @dragend="end"
    @dragstart="move"
  >
    <span class="BacklogOrder__title">{{ order.title }}</span>
    <span class="BacklogOrder__id">{{ order.id }}</span>
    <span class="BacklogOrder__duration">{{ order.duration }} min</span>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref } from 'vue'
import { Order } from '@/types'
import { GREY_DEFAULT } from '@/helpers'

export default defineComponent({
  name: 'Home',
  components: {},

  props: {
    order: {
      type: Object as PropType<Order>,
      required: true,
    },

    resolution: {
      type: Number,
      required: true,
    },
  },

  setup(props) {
    const element = ref<HTMLDivElement>()
    const moving = ref(false)

    return {
      moving,
      element,
      scheduleToStyle: computed(() => ({
        color:
          props.order.material.color !== GREY_DEFAULT ? 'white' : '#444444',
        width:
          Math.floor((props.order.duration / 60) * props.resolution) + 'px',
        backgroundColor: props.order.material.color,
      })),
    }
  },

  methods: {
    move(e: DragEvent) {
      this.moving = true
      if (e.dataTransfer) {
        e.dataTransfer.dropEffect = 'move'
        e.dataTransfer.effectAllowed = 'move'
        e.dataTransfer.setData('orderId', this.order.id)
        if (this.element) {
          e.dataTransfer.setData(
            'offset',
            (e.x - this.element.getBoundingClientRect().x).toString()
          )
        }
      }
    },
    end() {
      this.moving = false
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.BacklogOrder {
  position: relative;
  display: grid;
  grid-template-areas:
    'Title Title'
    'ID duration';
  grid-template-rows: 1fr minmax(min-content, auto);
  grid-template-columns: 1fr 1fr;
  gap: v.$spacing/2;
  max-height: v.$machine-lineHeight - v.$spacing;
  margin: v.$spacing/2;
  padding: 10px;
  border-radius: 3px;
  background: #dbdbdb;
  color: white;
  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.15);
  cursor: grab;

  &--moving {
    background-image:
      repeating-linear-gradient(145deg,
      #ccc,
      #ccc 30px,
      #dbdbdb 30px,
      #dbdbdb 60px);
    color: #000;
    transition: background-color linear 200ms;
  }

  &__title {
    grid-area: Title;
    font-weight: 700;
    font-size: 10pt;
  }

  &__id {
    grid-area: ID;
    font-style: italic;
    font-size: 0.8em;
  }

  &__duration {
    grid-area: duration;
    align-self: flex-end;
    font-size: 0.8em;
    text-align: right;
  }
}
</style>
